VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGroup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'
Private Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal crTransparent As Long) As Boolean


'Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Dest As Any, Src As Any, ByVal cb&)
Private Declare Function gethostbyaddr Lib "wsock32.dll" (addr As Long, ByVal addr_len As Long, ByVal addr_type As Long) As Long
Private Declare Function inet_addr Lib "wsock32.dll" (ByVal addr As String) As Long
'Private Declare Function GetHostByName Lib "wsock32.dll" Alias "gethostbyname" (ByVal HostName As String) As Long
Private Declare Function GetHostName Lib "wsock32.dll" Alias "gethostname" (ByVal HostName As String, HostLen As Long) As Long
'Private Declare Function WSAStartup Lib "wsock32.dll" (ByVal a As Long, b As T_WSA) As Long
'Private Declare Function WSACleanUp Lib "wsock32.dll" Alias "WSACleanup" () As Integer


'   
Private Type NETRESOURCE
    dwScope As Long
    dwType As Long
    dwDisplayType As Long
    dwUsage As Long
    lpLocalName As Long
    lpRemoteName As Long
    lpComment As Long
    lpProvider As Long
End Type

Private Declare Function WNetOpenEnum Lib "mpr.dll" Alias "WNetOpenEnumA" (ByVal dwScope As Long, ByVal dwType As Long, ByVal dwUsage As Long, lpNetResource As Any, lphEnum As Long) As Long
Private Declare Function WNetEnumResource Lib "mpr.dll" Alias "WNetEnumResourceA" (ByVal hEnum As Long, lpcCount As Long, ByVal lpBuffer As Long, lpBufferSize As Long) As Long
Private Declare Function WNetCloseEnum Lib "mpr.dll" (ByVal hEnum As Long) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
'Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function CopyPointer2String Lib "kernel32" Alias "lstrcpyA" (ByVal NewString As String, ByVal OldString As Long) As Long
Private Const RESOURCE_CONNECTED = &H1
Private Const RESOURCE_GLOBALNET = &H2
Private Const RESOURCE_REMEMBERED = &H3
Private Const RESOURCETYPE_ANY = &H0
Private Const RESOURCETYPE_DISK = &H1
Private Const RESOURCETYPE_PRINT = &H2
Private Const RESOURCETYPE_UNKNOWN = &HFFFF
Private Const RESOURCEUSAGE_CONNECTABLE = &H1
Private Const RESOURCEUSAGE_CONTAINER = &H2
Private Const RESOURCEUSAGE_RESERVED = &H80000000
Private Const GMEM_FIXED = &H0
Private Const GMEM_ZEROINIT = &H40
Private Const GPTR = (GMEM_FIXED Or GMEM_ZEROINIT)

'
Private Type t_Location
    x As Single
    Y As Single
End Type


Private col_Units As New Collection

Private c_Name As String
Private c_main_Picture As PictureBox

' 
Private Move_Location As t_Location
Private select_Unit As Long


'   
Private Sub Class_Initialize()
    Set col_Units = New Collection
End Sub
Private Sub Class_Terminate()
    Set col_Units = Nothing
    Set c_main_Picture = Nothing
End Sub

'   
Public Property Let Set_Main_Picture(ByVal vNewValue As PictureBox)
    Set c_main_Picture = vNewValue
End Property

' 
Public Property Get Name() As String
    Name = c_Name
End Property
Public Property Let Name(ByVal vNewValue As String)
    c_Name = vNewValue
End Property

Public Function Get_IP(Index As Long) As String
    Get_IP = col_Units(Index).IP
End Function

Public Function Get_Name(Index As Long) As String
    Get_Name = col_Units(Index).Name
End Function

Public Function Get_Type(Index As Long) As Long
    Get_Type = col_Units(Index).type_Unit
End Function

Public Function Get_Count_Units() As Long
    Get_Count_Units = col_Units.Count
End Function

Public Function Put_Active(Index As Long, flg As Boolean)
    col_Units(Index).Active = flg
End Function


'  
Private Function Check_Same(Name As String, m() As String) As Long
    Dim I As Long
    For I = 1 To UBound(m)
        If UCase(Name) = UCase(m(I)) Then
            Check_Same = I
            Exit Function
        End If
    Next
End Function

Public Function Get_All_Connection(Index As Long, m_out() As String)
    Dim m() As String, m2() As String, m_res() As String
    Dim I As Long, J As Long
    ReDim m_res(0)
    col_Units(Index).Get_Connections m_res
    For I = 1 To col_Units.Count
        If Index <> I Then
            col_Units(I).Get_Connections m2
            For J = 1 To UBound(m2)
                If UCase(m2(J)) = UCase(col_Units(Index).Name) Then
                    ReDim Preserve m_res(UBound(m_res) + 1)
                    m_res(UBound(m_res)) = col_Units(I).Name
                End If
            Next
        End If
    Next
    m_out = m_res
End Function


Public Function Get_Connection(Index As Long, m_out() As String)
    col_Units(Index).Get_Connections m_out
End Function

'   
Public Function Add_Connection(Name_Unit As String, Name_Unit2 As String) As Long
    Dim I As Long, m() As String
    Dim J As Long
    
    '   
    J = Check_Same_Name(Name_Unit)
    col_Units(J).Get_Connections m
    '  
    If Check_Same(Name_Unit2, m) = 0 Then
    '   
        I = Check_Same_Name(Name_Unit2)
        col_Units(I).Get_Connections m
        If Check_Same(Name_Unit, m) = 0 Then
        ' 
            col_Units(J).Get_Connections m
            ReDim Preserve m(UBound(m) + 1)
            m(UBound(m)) = Name_Unit2
            col_Units(J).Put_Connections m
            Add_Connection = 0
            Exit Function
        End If
    End If
    Add_Connection = -1
End Function

'   
Public Function Check_Same_Name(Name As String) As Long
    Dim I As Long
    For I = 1 To col_Units.Count
        If UCase(Name) = UCase(col_Units(I).Name) Then
            Check_Same_Name = I
            Exit Function
        End If
    Next
End Function

' 
Public Function Put_Move_Loaction(type_Move As Long, Index As Long, x As Single, Y As Single)
    Dim flg As Boolean
    If type_Move = 1 Then
    ' 
        select_Unit = Index
        Move_Location.x = x - col_Units(Index).x
        Move_Location.Y = Y - col_Units(Index).Y
    Else
    '
        If x - Move_Location.x < 0 Then
            col_Units(Index).x = 0
        ElseIf x - Move_Location.x > c_main_Picture.Width - 480 Then
            col_Units(Index).x = c_main_Picture.Width - 480
        Else
            col_Units(Index).x = x - Move_Location.x
        End If
        
        If Y - Move_Location.Y < 0 Then
            col_Units(Index).Y = 0
        ElseIf Y - Move_Location.Y > c_main_Picture.Height - 480 Then
            col_Units(Index).Y = c_main_Picture.Height - 480
        Else
            col_Units(Index).Y = Y - Move_Location.Y
        End If
        Me.Graf
    End If
End Function

'   picture
Public Function Check_Unit_Picture(x As Single, Y As Single) As Long
    Dim I As Long
    For I = 1 To col_Units.Count
        If x > col_Units(I).x And x < col_Units(I).x + 480 And Y > col_Units(I).Y And Y < col_Units(I).Y + 480 Then
            Check_Unit_Picture = I
            Exit Function
        End If
    Next
End Function

'  
Public Function Graf()
    Dim I As Long, J As Long, k As Long, m() As String
    Dim pct_Unit As PictureBox
    c_main_Picture.Cls
    
    ' 
    For I = 1 To col_Units.Count
        col_Units(I).Get_Connections m
        If UBound(m) <> 0 Then
            For J = 1 To UBound(m)
                k = Check_Same_Name(m(J))
                c_main_Picture.Line (col_Units(I).x + 240, col_Units(I).Y + 240)-(col_Units(k).x + 240, col_Units(k).Y + 240), vbBlue
            Next
        End If
    Next
    '
    For I = 1 To col_Units.Count
        '    
        If col_Units(I).Active = True Then
            Set pct_Unit = frmMain.pct_Active_Unit(col_Units(I).type_Unit)
            c_main_Picture.ForeColor = vbBlack
        Else
            Set pct_Unit = frmMain.pct_Deactive_Unit(col_Units(I).type_Unit)
            c_main_Picture.ForeColor = &HC0C0C0
        End If
        TransparentBlt c_main_Picture.hdc, col_Units(I).x / Screen.TwipsPerPixelX, col_Units(I).Y / Screen.TwipsPerPixelY, 32, 32, pct_Unit.hdc, 0, 0, 32, 32, vbBlack
        
        Set pct_Unit = Nothing
        '   
        c_main_Picture.CurrentX = col_Units(I).x + 490
        c_main_Picture.CurrentY = col_Units(I).Y + 150
        
        If col_Units(I).Comment <> "" Then
            c_main_Picture.Print col_Units(I).Name & " (" & col_Units(I).Comment & ")"
        Else
            c_main_Picture.Print col_Units(I).Name
        End If
        
        If col_Units(I).type_Unit <> 2 Then
            c_main_Picture.CurrentY = c_main_Picture.CurrentY + c_main_Picture.TextHeight(Time) / Screen.TwipsPerPixelY
            c_main_Picture.CurrentX = col_Units(I).x + 490
            c_main_Picture.FontBold = False
            If col_Units(I).IP <> "0.0.0.0" Then c_main_Picture.Print col_Units(I).IP Else c_main_Picture.Print ""
            c_main_Picture.FontBold = True
        End If
    Next
End Function

'  
Public Function Del_Same(Index As Long, InName As String) As Long
    Dim m() As String, c As String
    Dim I As Long, J As Long
    col_Units(Index).Get_Connections m
    If Check_Same(InName, m) <> 0 Then
        J = 1
        Do While J <= UBound(m)
            If UCase(InName) = UCase(m(J)) Then
                For I = J To UBound(m) - 1
                    m(I) = m(I + 1)
                Next
                ReDim Preserve m(UBound(m) - 1)
                J = J - 1
            End If
            J = J + 1
        Loop
        col_Units(Index).Put_Connections m
    End If
End Function

'     
Private Function Change_Same(Index As Long, InName As String, OutName As String) As Long
    Dim m() As String
    Dim I As Long
        
    col_Units(Index).Get_Connections m
    If Check_Same(InName, m) <> 0 Then
        For I = 1 To UBound(m)
            If UCase(InName) = UCase(m(I)) Then
                m(I) = OutName
            End If
        Next
        col_Units(Index).Put_Connections m
    End If
    
End Function

'    
Public Function Change_Unit(Index As Long, Name As String, Optional IP As String = "0.0.0.0", Optional type_Unit As t_type_Unit = Computer)
    Dim ct_Name As String, m() As String
    Dim I As Long

    ct_Name = col_Units(Index).Name

    col_Units(Index).Name = Name
    col_Units(Index).IP = IP
    col_Units(Index).type_Unit = type_Unit

    For I = 1 To col_Units.Count
        Change_Same I, ct_Name, Name
    Next

End Function

'  
Public Function Del_Unit(Index As Long) As Long
    Dim I As Long

    For I = 1 To col_Units.Count
        Del_Same I, col_Units(Index).Name
    Next
    col_Units.Remove Index
End Function

'    
Public Function Add_Unit(Name As String, Optional IP As String = "0.0.0.0", Optional type_Unit As t_type_Unit = Computer, Optional Active As Boolean = True, Optional x As Long = 0, Optional Y As Long = 0, Optional Comment As String = "") As Long
    Dim I As Long
    '    
    I = Check_Same_Name(Name)
    If I <> 0 Then
    
        
    
        Add_Unit = -1
        
        If col_Units(I).Name <> Name Then
            col_Units(I).Name = Name
        End If
        If col_Units(I).IP <> IP Then
            col_Units(I).IP = IP
        End If
        If col_Units(I).Comment <> Comment Then
            col_Units(I).Comment = Comment
        End If
        If col_Units(I).type_Unit <> type_Unit Then
            col_Units(I).type_Unit = type_Unit
        End If
        Exit Function
    End If
    Dim flg As Boolean
    
    If x = 0 And Y = 0 Then
        flg = False
        Do While flg = False
            flg = True
            Randomize Timer
            
            x = Int(Rnd * c_main_Picture.Width)
            Y = Int(Rnd * c_main_Picture.Height)
            If x > c_main_Picture.Width - 480 Then x = c_main_Picture.Width - 480
            If Y > c_main_Picture.Height - 480 Then Y = c_main_Picture.Height - 480
            
            For I = 1 To col_Units.Count
                If x > col_Units(I).x And x < col_Units(I).x + 480 Then
                    If Y > col_Units(I).Y And Y < col_Units(I).Y + 480 Then
                        flg = False
                        Exit For
                    End If
                End If
            Next
            
        Loop
    End If
    
    '  
    Dim f_Unit As New clsUnit
    Set f_Unit = New clsUnit
        f_Unit.Name = Name
        f_Unit.Comment = Comment
        f_Unit.Active = Active
        f_Unit.type_Unit = type_Unit
        f_Unit.IP = IP
        f_Unit.x = x
        f_Unit.Y = Y
        col_Units.Add f_Unit
    Set f_Unit = Nothing
End Function

' 
Public Function Load_Net(name_File As String) As Long
    On Error GoTo errorHandle
    Dim FSO As New FileSystemObject, d
    Dim I As Long, st As String
    Dim J As Long, m() As String, m2() As String
    Set d = FSO.OpenTextFile(name_File, ForReading)
    J = 1
    st = d.ReadLine
    Me.Name = st
    st = d.ReadLine:   st = d.ReadLine
    Do
        m = Split(st, ",")
        Me.Add_Unit m(0), m(2), Val(m(1)), True, Val(m(3)), Val(m((4))), m(5)
        st = d.ReadLine
    Loop While st <> ""
    J = 1
    Do While d.AtEndOfStream <> True
        st = d.ReadLine
        m = Split(st, ",")
        For I = 0 To UBound(m) - 1
            Me.Add_Connection col_Units(J).Name, m(I)
        Next
        J = J + 1
    Loop

    Set d = Nothing
    Set FSO = Nothing
    Load_Net = 0
    Exit Function
errorHandle:
    Set d = Nothing
    Set FSO = Nothing
    
    Load_Net = -1
    
End Function

' 
Public Function Save_Net(name_File As String) As Long
    Dim FSO As New FileSystemObject, d
    Dim I As Long, st As String
    Dim J As Long, m() As String
    Set d = FSO.CreateTextFile(name_File, True)
    Set d = Nothing
    Set d = FSO.OpenTextFile(name_File, ForWriting)
    d.WriteLine Me.Name
    d.WriteLine ""
    For I = 1 To col_Units.Count
        st = col_Units(I).Name & "," & CStr(col_Units(I).type_Unit) & "," & col_Units(I).IP & "," & _
        CStr(col_Units(I).x) & "," & CStr(col_Units(I).Y) & "," & CStr(col_Units(I).Comment)
        d.WriteLine st
    Next
    d.WriteLine ""
    For I = 1 To col_Units.Count
        col_Units(I).Get_Connections m
        st = ""
        For J = 1 To UBound(m)
            st = st & CStr(m(J)) & ","
        Next
        d.WriteLine st

    Next
    Set d = Nothing
    Set FSO = Nothing
End Function

'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

Public Function Check_PING_One(Index As Long) As Long
    Check_PING_One = Eco(col_Units(Index).IP)
End Function

Public Function Check_PING() As Long
    Dim Res As Long, I As Long, IP As String
    For I = 1 To col_Units.Count
        If col_Units(I).type_Unit <> Hub Then
        
            If col_Units(I).IP = "0.0.0.0" Then
                WinsockInit
                IP = HostByName(col_Units(I).Name)
                WSACleanUp
                col_Units(I).IP = IP
            End If
        
        
            If col_Units(I).IP = "0.0.0.0" Then
                col_Units(I).Active = False
            
            Else
                Res = Eco(col_Units(I).IP)
                If Res = -1 Then
                    col_Units(I).Active = False
                Else
                    col_Units(I).Active = True
                End If
            End If
        End If
    Next
End Function

'!!!!!!!!!!!!!! !!!!!!!!!!!!
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Public Function Scan_Net()
    DoNetEnum
End Function

Private Function DoNetEnum() As Boolean
    Dim hEnum As Long, lpBuff As Long, NR As NETRESOURCE, cbBuff As Long, cCount As Long, p As Long, Res As Long, I As Long
    On Error GoTo ErrorHandler
    NR.lpRemoteName = 0
    cbBuff = 10000
    cCount = &HFFFFFFFF
    Res = WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, 0, NR, hEnum)
    If Res = 0 Then
        lpBuff = GlobalAlloc(GPTR, cbBuff)
        Res = WNetEnumResource(hEnum, cCount, lpBuff, cbBuff)
        If Res = 0 Then
            p = lpBuff
            For I = 1 To cCount
                CopyMemory NR, ByVal p, LenB(NR)
                DoNetEnum2 NR
                p = p + LenB(NR)
                DoEvents
            Next I
        End If
        DoNetEnum = True
ErrorHandler:
        On Error Resume Next
        If lpBuff <> 0 Then GlobalFree (lpBuff)
        WNetCloseEnum (hEnum)
    End If
End Function
Private Sub DoNetEnum2(NR As NETRESOURCE)
    Dim hEnum As Long, lpBuff As Long, cbBuff As Long, cCount As Long
    Dim p As Long, Res As Long, I As Long, nResurce As String, tmp_Name_Comp As String, J As Long, IP As String
    cbBuff = 10000
    cCount = &HFFFFFFFF
    Res = WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, 0, NR, hEnum)
    If Res = 0 Then
        lpBuff = GlobalAlloc(GPTR, cbBuff)
        Res = WNetEnumResource(hEnum, cCount, lpBuff, cbBuff)
        If Res = 0 Then
            p = lpBuff
            For I = 1 To cCount
                CopyMemory NR, ByVal p, LenB(NR)
                Debug.Print PointerToString(NR.lpRemoteName) & PointerToString(NR.lpComment)
                Select Case NR.dwDisplayType
                    Case Is = 1
                        Me.Name = PointerToString(NR.lpRemoteName)
                    Case Is = 2
                        tmp_Name_Comp = PointerToString(NR.lpRemoteName)
                        J = Me.Add_Unit(Right(tmp_Name_Comp, Len(tmp_Name_Comp) - 2), , , , , , PointerToString(NR.lpComment))
                End Select
                DoNetEnum2 NR
                p = p + LenB(NR)
                DoEvents
            Next I
        End If
        If lpBuff <> 0 Then GlobalFree (lpBuff)
        WNetCloseEnum (hEnum)
    End If
End Sub
Private Function PointerToString(p As Long) As String
    Dim s As String
    s = String(255, Chr$(0))
    CopyPointer2String s, p
    PointerToString = Left(s, InStr(s, Chr$(0)) - 1)
End Function

Private Sub WinsockInit()
    WSAStartup &H101, WSADataS
End Sub



