VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsUnit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum t_type_Unit
    Computer = 1
    Hub = 2
    Gate = 3
    Printer = 4
End Enum

Private c_type_Unit As t_type_Unit
Private c_X As Single, c_Y As Single
Private c_Name As String, c_IP As String, c_Comment As String
Private c_Active As Boolean
Private c_Connection() As String

'   
Public Property Get type_Unit() As t_type_Unit
    type_Unit = c_type_Unit
End Property
Public Property Let type_Unit(ByVal vNewValue As t_type_Unit)
    c_type_Unit = vNewValue
End Property

'   
Public Property Get x() As Single
    x = c_X
End Property
Public Property Let x(ByVal vNewValue As Single)
    c_X = vNewValue
End Property
Public Property Get Y() As Single
    Y = c_Y
End Property
Public Property Let Y(ByVal vNewValue As Single)
    c_Y = vNewValue
End Property

'
Public Property Get Comment() As String
    Comment = c_Comment
End Property
Public Property Let Comment(ByVal vNewValue As String)
    c_Comment = vNewValue
End Property

' 
Public Property Get Name() As String
    Name = c_Name
End Property
Public Property Let Name(ByVal vNewValue As String)
    c_Name = vNewValue
End Property

'IP  
Public Property Get IP() As String
    IP = c_IP
End Property
Public Property Let IP(ByVal vNewValue As String)
    c_IP = vNewValue
End Property

'       
Public Property Get Active() As Boolean
    Active = c_Active
End Property
Public Property Let Active(ByVal vNewValue As Boolean)
    c_Active = vNewValue
End Property

'     
Public Sub Get_Connections(m_out() As String)
    m_out = c_Connection
End Sub
Public Sub Put_Connections(m_in() As String)
    c_Connection = m_in
End Sub

Private Sub Class_Initialize()
    ReDim c_Connection(0)
    c_Connection(0) = ""
    c_IP = "0.0.0.0"
    c_Active = True
End Sub
