VERSION 5.00
Begin VB.UserControl txt_Text 
   ClientHeight    =   555
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2085
   FillStyle       =   0  'Solid
   ScaleHeight     =   555
   ScaleWidth      =   2085
   Begin VB.TextBox txt_Tmp 
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1575
   End
   Begin VB.Line lnl_Frame 
      Index           =   3
      X1              =   120
      X2              =   1320
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Line lnl_Frame 
      Index           =   2
      X1              =   120
      X2              =   1320
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Line lnl_Frame 
      Index           =   1
      X1              =   0
      X2              =   1200
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Line lnl_Frame 
      Index           =   0
      X1              =   0
      X2              =   1200
      Y1              =   0
      Y2              =   0
   End
End
Attribute VB_Name = "txt_Text"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Event Click()
'Event DblClick()

'Event MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
'Event MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
'Event MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)

Event Change()

Private m_Text As String, m_Enabled As Boolean, m_BackColor As Long, m_ForeColor As Long, _
    m_FrameColor As Long, m_SelStart As Long, m_SelLength As Long

Private m_Visible As Boolean

Private m_MaxLength As Long

Private Sub txt_Tmp_Change()
    Me.Text = txt_Tmp.Text
    Check_Max
    RaiseEvent Change
End Sub

Private Sub UserControl_Initialize()
    UserControl_Resize
    
    Me.Text = ""
    Me.Enabled = True
    Me.BackColor = vbWhite
    Me.ForeColor = vbBlack
    Me.FrameColor = 12164479
    Me.Visible = True
End Sub

Private Function Check_Max()
    Dim I As Long
    
    If m_MaxLength <> 0 Then
        I = txt_Tmp.SelStart
        Me.Text = Left(Me.Text, m_MaxLength)
        txt_Tmp.SelStart = I
        
    End If
End Function

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        Call .WriteProperty("Text", m_Text, "")
        Call .WriteProperty("MaxLen", m_MaxLength, "0")
    End With
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With PropBag
        m_Text = .ReadProperty("Text", "")
        Me.Text = m_Text
        
        m_MaxLength = Val(.ReadProperty("MaxLen", ""))
        Check_Max
        
    End With
End Sub

Private Sub UserControl_Resize()
    txt_Tmp.Top = 30
    txt_Tmp.Left = 30
    txt_Tmp.Width = UserControl.Width - 50
    txt_Tmp.Height = UserControl.Height - 50
    lnl_Frame(0).X1 = 0: lnl_Frame(0).Y1 = 0: lnl_Frame(0).X2 = UserControl.Width:  lnl_Frame(0).Y2 = 0
    lnl_Frame(1).X1 = 0: lnl_Frame(1).Y1 = 0: lnl_Frame(1).X2 = 0: lnl_Frame(1).Y2 = UserControl.Height
    lnl_Frame(2).X1 = UserControl.Width - 10: lnl_Frame(2).Y1 = 3: lnl_Frame(2).X2 = UserControl.Width - 10: lnl_Frame(2).Y2 = UserControl.Height
    lnl_Frame(3).X1 = 0: lnl_Frame(3).Y1 = UserControl.Height - 10: lnl_Frame(3).X2 = UserControl.Width - 10: lnl_Frame(3).Y2 = UserControl.Height - 10
    lnl_Frame(0).BorderColor = Me.FrameColor
    lnl_Frame(1).BorderColor = Me.FrameColor
    lnl_Frame(2).BorderColor = Me.FrameColor
    lnl_Frame(3).BorderColor = Me.FrameColor
End Sub

Public Property Get MaxLength() As Long
    MaxLength = m_MaxLength
End Property

Public Property Let MaxLength(ByVal vNewValue As Long)
    If vNewValue < 0 Or m_MaxLength > 32000 Then Exit Property
    m_MaxLength = vNewValue
    
    Check_Max
    'txt_Tmp.Visible = m_Visible
End Property



Public Property Get Visible() As Boolean
    Visible = m_Visible
End Property

Public Property Let Visible(ByVal vNewValue As Boolean)
    m_Visible = vNewValue
    txt_Tmp.Visible = m_Visible
End Property

Public Property Get SelLength() As Long
    SelLength = m_SelLength
End Property

Public Property Let SelLength(ByVal vNewValue As Long)
    m_SelLength = vNewValue
    txt_Tmp.SelLength = m_SelLength
End Property

Public Property Get SelStart() As Long
    SelStart = m_SelStart
End Property

Public Property Let SelStart(ByVal vNewValue As Long)
    m_SelStart = vNewValue
    txt_Tmp.SelStart = m_SelStart
End Property

Public Property Get FrameColor() As Long
    FrameColor = m_FrameColor
End Property

Public Property Let FrameColor(ByVal vNewValue As Long)
    m_FrameColor = vNewValue
    UserControl_Resize
End Property

Public Property Get ForeColor() As Long
    ForeColor = m_ForeColor
End Property

Public Property Let ForeColor(ByVal vNewValue As Long)
    m_ForeColor = vNewValue
    txt_Tmp.ForeColor = m_ForeColor
End Property

Public Property Get BackColor() As Long
    BackColor = m_BackColor
End Property

Public Property Let BackColor(ByVal vNewValue As Long)
    m_BackColor = vNewValue
    txt_Tmp.BackColor = m_BackColor
End Property

Public Property Get Enabled() As Boolean
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal vNewValue As Boolean)
    m_Enabled = vNewValue
    txt_Tmp.Enabled = m_Enabled
End Property

Public Property Get Text() As String
    Text = m_Text
End Property

Public Property Let Text(ByVal vNewValue As String)
    m_Text = vNewValue
    txt_Tmp.Text = m_Text
End Property

